package org.codehaus.redback.integration.taglib.jsp;

/*
 * Copyright 2006 The Codehaus.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import org.codehaus.plexus.redback.users.UserManager;

import javax.servlet.jsp.JspTagException;
import javax.servlet.jsp.jstl.core.ConditionalTagSupport;
import org.codehaus.plexus.spring.PlexusToSpringUtils;
import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

/**
 * IsReadOnlyUserManagerTag:
 *
 * @author Jesse McConnell <jesse@codehaus.org>
 * @version $Id: IsNotReadOnlyUserManagerTag.java 656 2008-11-01 21:01:30Z olamy $
 */
public class IsNotReadOnlyUserManagerTag
    extends ConditionalTagSupport
{
    protected boolean condition()
        throws JspTagException
    { 
        ApplicationContext applicationContext = WebApplicationContextUtils.getRequiredWebApplicationContext(pageContext.getServletContext());

        UserManager config = (UserManager) applicationContext.getBean(PlexusToSpringUtils.buildSpringId(UserManager.ROLE, "configurable"));           
        if (config == null)
        {
            throw new JspTagException( "unable to locate security system" );
        }

        return !config.isReadOnly();
    }
}
